# TiPi

Master: ![Travis build status](https://travis-ci.com/emmt/TiPi.svg?branch=eric-devel)

TiPi is a Java *Toolkit for Inverse Problems and Imaging* developed as part of
the MiTiV project <http://mitiv.univ-lyon1.fr/> and supported by the
**Magnum2** project.  The objective of TiPi is to provide a framework for
developping algorithms to sove inverse problems notably for image restoration.
TiPi has a number of applications, for instance:

* **Astronomy**: TiPi is used for the deblurring and denoising of astronomical
  images.

* **Magnum2** project: TiPi is used to repair (inpainting) and enhance
  (deblurring and denoising) images of license plates before automatic OCR.

* **Microscopy**: TiPi is exploited to implement the
  [Icy](http://icy.bioimageanalysis.org/) plugins for *deconvolution* and
  *blind deconvolution* of 3D images.


## Documentation

Asside from the [Javadoc](http://emmt.github.io/TiPi/) produded from the
source, the framework provided by TiPi is described in the
[*TiPi Framework*](http://emmt.github.io/TiPi) which we recommend to
read first.

## Build

Build with Maven:
```bash
mvn package
```